import * as settingActions from 'background/actions/setting';
import messages from 'shared/messages';
import BackgroundComponent from 'background/components/background';
import OperationComponent from 'background/components/operation';
import TabComponent from 'background/components/tab';
import reducers from 'background/reducers';
import { createStore } from 'shared/store';
import * as versions from 'shared/versions';

const store = createStore(reducers, (e, sender) => {
  console.error('Vim-Vixen:', e);
  if (sender) {
    return browser.tabs.sendMessage(sender.tab.id, {
      type: messages.CONSOLE_SHOW_ERROR,
      text: e.message,
    });
  }
});
// eslint-disable-next-line no-unused-vars
const backgroundComponent = new BackgroundComponent(store);
// eslint-disable-next-line no-unused-vars
const operationComponent = new OperationComponent(store);
// eslint-disable-next-line no-unused-vars
const tabComponent = new TabComponent(store);

store.dispatch(settingActions.load());

versions.checkUpdated().then((updated) => {
  if (!updated) {
    return;
  }
  return versions.notify();
}).then(() => {
  return versions.commit();
});
